diff --git a/src/test/modules/index/test_indexscan.c b/src/test/modules/index/test_indexscan.c
new file mode 100644
index 000000000..bb299ca33
--- /dev/null
+++ b/src/test/modules/index/test_indexscan.c
@@ -0,0 +1,152 @@
+/*--------------------------------------------------------------------------
+ *
+ * test_indexscan.c
+ *		Test helpers for low-level index scan behavior.
+ *
+ * Copyright (c) 2026, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *		src/test/modules/index/test_indexscan.c
+ *
+ * -------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "access/amapi.h"
+#include "access/genam.h"
+#include "access/relscan.h"
+#include "access/table.h"
+#include "access/tableam.h"
+#include "catalog/index.h"
+#include "executor/tuptable.h"
+#include "fmgr.h"
+#include "funcapi.h"
+#include "miscadmin.h"
+#include "storage/itemptr.h"
+#include "utils/builtins.h"
+#include "utils/rel.h"
+#include "utils/tuplestore.h"
+
+PG_MODULE_MAGIC;
+
+/*
+ * index_scan_tids(indexrel regclass, snaptype text, dir text) RETURNS SETOF tid
+ *
+ * Scan indexrel with zero scan keys, using a snapshot of the given type and
+ * the given scan direction, and return the heap TID of every tuple that the
+ * scan returns, in scan order.
+ */
+PG_FUNCTION_INFO_V1(index_scan_tids);
+Datum
+index_scan_tids(PG_FUNCTION_ARGS)
+{
+	Oid			indexoid = PG_GETARG_OID(0);
+	char	   *snaptype = text_to_cstring(PG_GETARG_TEXT_PP(1));
+	char	   *dirstr = text_to_cstring(PG_GETARG_TEXT_PP(2));
+	ReturnSetInfo *rsinfo = (ReturnSetInfo *) fcinfo->resultinfo;
+	Oid			heapoid;
+	Relation	heaprel;
+	Relation	indexrel;
+	ScanDirection dir;
+	SnapshotData snapdata;
+	Snapshot	snapshot;
+	IndexScanDesc scan;
+	TupleTableSlot *slot;
+
+	if (!superuser())
+		ereport(ERROR,
+				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
+				 errmsg("must be superuser to use index scan test functions")));
+
+	InitMaterializedSRF(fcinfo, MAT_SRF_USE_EXPECTED_DESC);
+
+	if (strcmp(dirstr, "forward") == 0)
+		dir = ForwardScanDirection;
+	else if (strcmp(dirstr, "backward") == 0)
+		dir = BackwardScanDirection;
+	else
+		ereport(ERROR,
+				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+				 errmsg("invalid scan direction \"%s\"", dirstr)));
+
+	/*
+	 * Lock the heap before the index to avoid deadlock.  IndexGetRelation()
+	 * runs without a lock, so if the OID isn't an index it returns
+	 * InvalidOid; defer the complaint to index_open() below, which gives a
+	 * better message.
+	 */
+	heapoid = IndexGetRelation(indexoid, true);
+	if (OidIsValid(heapoid))
+		heaprel = table_open(heapoid, AccessShareLock);
+	else
+		heaprel = NULL;
+
+	indexrel = index_open(indexoid, AccessShareLock);
+
+	/*
+	 * Since the IndexGetRelation() call above ran without a lock, recheck now
+	 * that both relations are locked: a concurrent drop and recreate could
+	 * have left us with the wrong heap.
+	 */
+	if (heaprel == NULL || heapoid != IndexGetRelation(indexoid, false))
+		ereport(ERROR,
+				(errcode(ERRCODE_UNDEFINED_TABLE),
+				 errmsg("could not open parent table of index \"%s\"",
+						RelationGetRelationName(indexrel))));
+
+	if (indexrel->rd_indam->amgettuple == NULL)
+		ereport(ERROR,
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				 errmsg("index \"%s\" does not support plain index scans",
+						RelationGetRelationName(indexrel))));
+
+	if (strcmp(snaptype, "mvcc") == 0)
+		snapshot = GetActiveSnapshot();
+	else if (strcmp(snaptype, "any") == 0)
+		snapshot = SnapshotAny;
+	else if (strcmp(snaptype, "self") == 0)
+		snapshot = SnapshotSelf;
+	else if (strcmp(snaptype, "dirty") == 0)
+	{
+		InitDirtySnapshot(snapdata);
+		snapshot = &snapdata;
+	}
+	else if (strcmp(snaptype, "nonvacuumable") == 0)
+	{
+		InitNonVacuumableSnapshot(snapdata, GlobalVisTestFor(heaprel));
+		snapshot = &snapdata;
+	}
+	else
+		ereport(ERROR,
+				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+				 errmsg("invalid snapshot type \"%s\"", snaptype)));
+
+	slot = table_slot_create(heaprel, NULL);
+
+	scan = index_beginscan(heaprel, indexrel, false, snapshot, NULL,
+						   0, 0, SO_NONE);
+	index_rescan(scan, NULL, 0, NULL, 0);
+
+	while (table_index_getnext_slot(scan, dir, slot))
+	{
+		ItemPointerData tid = slot->tts_tid;
+		Datum		values[1];
+		bool		nulls[1];
+
+		/* with zero scan keys, no AM should ever request a recheck */
+		if (scan->xs_recheck)
+			elog(ERROR, "unexpected recheck request from keyless index scan");
+
+		values[0] = ItemPointerGetDatum(&tid);
+		nulls[0] = false;
+		tuplestore_putvalues(rsinfo->setResult, rsinfo->setDesc,
+							 values, nulls);
+	}
+
+	index_endscan(scan);
+	ExecDropSingleTupleTableSlot(slot);
+	index_close(indexrel, AccessShareLock);
+	table_close(heaprel, AccessShareLock);
+
+	return (Datum) 0;
+}
diff --git a/src/test/modules/index/test_indexscan.control b/src/test/modules/index/test_indexscan.control
new file mode 100644
index 000000000..bfab27bf0
--- /dev/null
+++ b/src/test/modules/index/test_indexscan.control
@@ -0,0 +1,4 @@
+comment = 'helper function for low-level index scan behavior'
+default_version = '1.0'
+module_pathname = '$libdir/test_indexscan'
+relocatable = true
diff --git a/src/test/regress/sql/stats.sql b/src/test/regress/sql/stats.sql
index 4c265d124..248267e22 100644
--- a/src/test/regress/sql/stats.sql
+++ b/src/test/regress/sql/stats.sql
@@ -403,6 +403,35 @@ SELECT pg_stat_reset_single_table_counters('test_last_scan_pkey'::regclass);
 SELECT idx_scan, stats_reset IS NOT NULL AS has_stats_reset
   FROM pg_stat_all_indexes WHERE indexrelid = 'test_last_scan_pkey'::regclass;
 
+-- Test pg_stat_all_indexes.idx_tup_read counter
+CREATE TEMPORARY TABLE test_idx_tup_read AS
+  SELECT g AS a FROM generate_series(1, 200) g;
+CREATE INDEX ON test_idx_tup_read(a);
+
+SET enable_seqscan = off;
+SET enable_indexonlyscan = off;
+-- plain index scan
+SET enable_bitmapscan = off;
+EXPLAIN (COSTS off) SELECT count(*) FROM test_idx_tup_read WHERE a BETWEEN 1 AND 200;
+SELECT count(*) FROM test_idx_tup_read WHERE a BETWEEN 1 AND 200;
+-- bitmap index scan
+SET enable_indexscan = off;
+SET enable_bitmapscan = on;
+EXPLAIN (COSTS off) SELECT count(*) FROM test_idx_tup_read WHERE a BETWEEN 1 AND 200;
+SELECT count(*) FROM test_idx_tup_read WHERE a BETWEEN 1 AND 200;
+RESET enable_seqscan;
+RESET enable_indexonlyscan;
+RESET enable_indexscan;
+RESET enable_bitmapscan;
+
+-- We expect a total of 400 tuples read (200 from plain index scan, 200 from
+-- bitmap index scan).  However, we only expect 200 tuple fetches, because
+-- bitmap index scans/heap scans don't affect the relevant counter.
+SELECT pg_stat_force_next_flush();
+SELECT idx_tup_read, idx_tup_fetch FROM pg_stat_all_indexes
+  WHERE indexrelid = 'test_idx_tup_read_a_idx'::regclass;
+DROP TABLE test_idx_tup_read;
+
 -----
 -- Test reset of some stats for shared table
 -----
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index eb3dd5481..3eb70548c 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -1335,8 +1335,6 @@ IndexDeleteCounts
 IndexDeletePrefetchState
 IndexDoCheckCallback
 IndexElem
-IndexFetchHeapData
-IndexFetchTableData
 IndexInfo
 IndexList
 IndexOnlyScan
@@ -1348,6 +1346,7 @@ IndexRuntimeKeyInfo
 IndexScan
 IndexScanDesc
 IndexScanDescData
+IndexScanHeapData
 IndexScanInstrumentation
 IndexScanState
 IndexStateFlagsAction
-- 
2.53.0

